Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -1132,9 +1487,5 @@
         ENDIF
 
-        IF ( mrt_factors ) THEN
-            IF ( debug_prints )  THEN
-                WRITE(9, *) myid, 'mrt factors start'
-                FLUSH(9)
-            ENDIF
+        IF ( mrt_factors )  THEN
             OPEN(153, file='MRT_TARGETS', access='SEQUENTIAL', &
                     action='READ', status='OLD', form='FORMATTED', err=524)
@@ -1144,6 +1495,6 @@
             DO
                 READ(153, *, end=526, err=524) imrtt, i, j, k
-                IF ( i < nxl .OR. i > nxr &
-                    .OR. j < nys .OR. j > nyn ) CYCLE
+                IF ( i < nxl  .OR.  i > nxr &
+                     .OR.  j < nys  .OR.  j > nyn ) CYCLE
                 tx = REAL(i)
                 ty = REAL(j)
@@ -1151,7 +1502,7 @@
 
                 DO isurfs = 1, nsurf
-                    IF ( .NOT. usm_facing(i, j, k, -1, &
+                    IF ( .NOT.  usm_facing(i, j, k, -1, &
                         surf(ix, isurfs), surf(iy, isurfs), &
-                        surf(iz, isurfs), surf(id, isurfs)) ) THEN
+                        surf(iz, isurfs), surf(id, isurfs)) )  THEN
                         CYCLE
                     ENDIF
@@ -1162,18 +1513,18 @@
                     sx = REAL(surf(ix, isurfs), wp) - 0.5_wp * idir(sd)
 
-                    !-- unit vector source -> target
+!--                 unit vector source -> target
                     uv = (/ (tz-sz)*dz, (ty-sy)*dy, (tx-sx)*dx /)
                     sqdist = SUM(uv(:)**2)
                     uv = uv / SQRT(sqdist)
 
-                    !-- irradiance factor - see svf. Here we consider that target face is always normal,
-                    !-- i.e. the second dot product equals 1
+!--                 irradiance factor - see svf. Here we consider that target face is always normal,
+!--                 i.e. the second dot product equals 1
                     rirrf = dot_product((/ kdir(sd), jdir(sd), idir(sd) /), uv) &
                         / (pi * sqdist) * facearea(sd)
 
-                    !-- raytrace while not creating any canopy sink factors
+!--                 raytrace while not creating any canopy sink factors
                     CALL usm_raytrace((/sz,sy,sx/), (/tz,ty,tx/), isurfs, rirrf, 1._wp, .FALSE., &
                             visible, transparency, win_lad)
-                    IF ( .NOT. visible ) CYCLE
+                    IF ( .NOT.  visible ) CYCLE
 
                     !rsvf = rirrf * transparency
@@ -1197,30 +1548,19 @@
 526         CLOSE(153)
             CLOSE(154)
-            IF ( debug_prints )  THEN
-                WRITE(9, *) myid, 'mrt factors finished', ncsfl !should be always 0
-                FLUSH(9)
-            ENDIF
         ENDIF  !< mrt_factors
 
         
         DO isurflt = 1, nsurfl
-            !-- determine face centers
+!--         determine face centers
             td = surfl(id, isurflt)
-            IF ( td >= isky .AND. .NOT. plant_canopy) CYCLE
+            IF ( td >= isky  .AND.  .NOT.  plant_canopy ) CYCLE
             tz = REAL(surfl(iz, isurflt), wp) - 0.5_wp * kdir(td)
             ty = REAL(surfl(iy, isurflt), wp) - 0.5_wp * jdir(td)
             tx = REAL(surfl(ix, isurflt), wp) - 0.5_wp * idir(td)
-            IF ( debug_prints ) THEN
-                WRITE(9,'(i3,a,i2,2i4, 4i6,3f7.2,4i6,3f7.2)') myid, 'svft1', &
-                    td, isurflt, nsurfl, &
-                    surfl(ix, isurflt), surfl(iy, isurflt), &
-                    surfl(iz, isurflt), surfl(id, isurflt), tx,ty,tz
-                FLUSH(9)
-            ENDIF
             DO isurfs = 1, nsurf
-                IF ( .NOT. usm_facing(surfl(ix, isurflt), surfl(iy, isurflt), &
+                IF ( .NOT.  usm_facing(surfl(ix, isurflt), surfl(iy, isurflt), &
                     surfl(iz, isurflt), surfl(id, isurflt), &
                     surf(ix, isurfs), surf(iy, isurfs), &
-                    surf(iz, isurfs), surf(id, isurfs)) ) THEN
+                    surf(iz, isurfs), surf(id, isurfs)) )  THEN
                     CYCLE
                 ENDIF
@@ -1231,35 +1571,30 @@
                 sx = REAL(surf(ix, isurfs), wp) - 0.5_wp * idir(sd)
 
-                !-- unit vector source -> target
+!--             unit vector source -> target
                 uv = (/ (tz-sz)*dz, (ty-sy)*dy, (tx-sx)*dx /)
                 sqdist = SUM(uv(:)**2)
                 uv = uv / SQRT(sqdist)
                 
-                !-- irradiance factor (our unshaded shape view factor) = view factor per differential target area * source area
+!--             irradiance factor (our unshaded shape view factor) = view factor per differential target area * source area
                 rirrf = dot_product((/ kdir(sd), jdir(sd), idir(sd) /), uv) & ! cosine of source normal and direction
-                    * dot_product((/ kdir(td), jdir(td), idir(td) /), -uv) & ! cosine of target normal and reverse direction
+                    * dot_product((/ kdir(td), jdir(td), idir(td) /), -uv) &  ! cosine of target normal and reverse direction
                     / (pi * sqdist) & ! square of distance between centers
                     * facearea(sd)
 
-                !-- raytrace + process plant canopy sinks within
+!--             raytrace + process plant canopy sinks within
                 CALL usm_raytrace((/sz,sy,sx/), (/tz,ty,tx/), isurfs, rirrf, facearea(td), .TRUE., &
                         visible, transparency, win_lad)
                 
-                IF ( .NOT. visible ) CYCLE
+                IF ( .NOT.  visible ) CYCLE
                 IF ( td >= isky ) CYCLE !< we calculated these only for raytracing
                                         !< to find plant canopy sinks, we don't need svf for them
-
-                !rsvf = rirrf * transparency
-
-                !-- write to the svf array
+                ! rsvf = rirrf * transparency
+
+!--             write to the svf array
                 nsvfl = nsvfl + 1
-                !-- check dimmension of asvf array and enlarge it if needed
-                IF ( nsvfla < nsvfl ) THEN
+!--             check dimmension of asvf array and enlarge it if needed
+                IF ( nsvfla < nsvfl )  THEN
                     k = nsvfla * 2
-                    IF ( debug_prints )  THEN
-                        WRITE(9,*) 'New dimmension of asvf array set to ', k
-                        FLUSH(9)
-                    ENDIF
-                    IF ( msvf == 0 ) THEN
+                    IF ( msvf == 0 )  THEN
                         msvf = 1
                         ALLOCATE( asvf1(k) )
@@ -1276,5 +1611,5 @@
                     nsvfla = k
                 ENDIF
-                !-- write svf values into the array
+!--             write svf values into the array
                 asvf(nsvfl)%isurflt = isurflt
                 asvf(nsvfl)%isurfs = isurfs
@@ -1284,27 +1619,14 @@
         ENDDO
 
-        WRITE(6,*) myid, 'waiting for completion of svf and csf calculation in all processes'
-        FLUSH(6)
+        CALL location_message( '    waiting for completion of SVF and CSF calculation in all processes', .TRUE. )
 
 #if defined( __parallel )
-        IF (plant_canopy) THEN
-            IF ( usm_lad_rma ) THEN
+        IF ( plant_canopy )  THEN
+            IF ( usm_lad_rma )  THEN
                 CALL MPI_Win_flush_all(win_lad, ierr)
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) 'MPI_Win_flush_all', myid, ierr
-                    FLUSH(9)
-                ENDIF
-                !-- unlock MPI window
+!--             unlock MPI window
                 CALL MPI_Win_unlock_all(win_lad, ierr)
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) 'MPI_Win_unlock_all', myid, ierr
-                    FLUSH(9)
-                ENDIF
-                !-- free MPI window
+!--             free MPI window
                 CALL MPI_Win_free(win_lad, ierr)
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) 'MPI_Win_free', myid, ierr
-                    FLUSH(9)
-                ENDIF
             ELSE
                 DEALLOCATE(usm_lad)
@@ -1316,35 +1638,18 @@
 #endif
 
-        !-- deallocate temporary global arrays
+!--     deallocate temporary global arrays
         IF ( ALLOCATED(nzterr) ) DEALLOCATE(nzterr)
         IF ( ALLOCATED(plantt) ) DEALLOCATE(plantt)
         
-        IF ( debug_prints ) THEN
-            WRITE(9,*) myid, 'writing svf finished, nsvfl', nsvfl, ', ncsfl', ncsfl
-            FLUSH(9)
-        ENDIF
-        ! sort svf ( a version of quicksort )
-        IF ( debug_prints ) THEN
-            WRITE(9,*) myid, 'start svf sort'
-            FLUSH(9)
-        ENDIF
+!--     sort svf ( a version of quicksort )
         CALL quicksort_svf(asvf,1,nsvfl)
-        IF ( debug_prints ) THEN
-            WRITE(9,*) myid, 'sort svf finished'
-            FLUSH(9)
-        ENDIF
         
         npcsfl = 0
-        IF (plant_canopy) THEN
-            ! sort and merge csf for the last time, keeping the array size to minimum
-            CALL merge_and_grow_csf(-1)
+        IF ( plant_canopy )  THEN
+!--         sort and merge csf for the last time, keeping the array size to minimum
+            CALL usm_merge_and_grow_csf(-1)
             
-            IF ( debug_prints ) THEN
-                WRITE(9,*) myid, 'distribute CSF into processors'
-                FLUSH(9)
-            ENDIF
-            
-            !-- aggregate csb among processors
-            !-- allocate necessary arrays
+!--         aggregate csb among processors
+!--         allocate necessary arrays
             ALLOCATE( csflt(ndcsf,max(ncsfl,ndcsf)) )
             ALLOCATE( kcsflt(kdcsf,max(ncsfl,kdcsf)) )
@@ -1354,7 +1659,7 @@
             ALLOCATE( dpcsflt(0:numprocs-1) )
             
-            !-- fill out arrays of csf values and 
-            !-- arrays of number of elements and displacements
-            !-- for particular precessors
+!--         fill out arrays of csf values and 
+!--         arrays of number of elements and displacements
+!--         for particular precessors
             icsflt = 0
             dcsflt = 0
@@ -1364,24 +1669,24 @@
             DO kcsf = 1, ncsfl
                 j = j+1
-                IF ( acsf(kcsf)%ip /= ip ) THEN
-                    !-- new block of the processor
-                    !-- number of elements of previous block
-                    IF (ip>=0) icsflt(ip) = j
+                IF ( acsf(kcsf)%ip /= ip )  THEN
+!--                 new block of the processor
+!--                 number of elements of previous block
+                    IF ( ip>=0) icsflt(ip) = j
                     d = d+j
-                    !-- blank blocks
+!--                 blank blocks
                     DO jp = ip+1, acsf(kcsf)%ip-1
-                        !-- number of elements is zero, displacement is equal to previous
+!--                     number of elements is zero, displacement is equal to previous
                         icsflt(jp) = 0
                         dcsflt(jp) = d
                     ENDDO
-                    !-- the actual block
+!--                 the actual block
                     ip = acsf(kcsf)%ip
                     dcsflt(ip) = d
                     j = 0
                 ENDIF
-                !-- fill out real values of rsvf, rtransp
+!--             fill out real values of rsvf, rtransp
                 csflt(1,kcsf) = acsf(kcsf)%rsvf
                 csflt(2,kcsf) = acsf(kcsf)%rtransp
-                !-- fill out integer values of itz,ity,itx,isurfs
+!--             fill out integer values of itz,ity,itx,isurfs
                 kcsflt(1,kcsf) = acsf(kcsf)%itz
                 kcsflt(2,kcsf) = acsf(kcsf)%ity
@@ -1389,27 +1694,27 @@
                 kcsflt(4,kcsf) = acsf(kcsf)%isurfs
             ENDDO
-            !-- last blank blocks at the end of array
+!--         last blank blocks at the end of array
             j = j+1
-            IF (ip>=0) icsflt(ip) = j
+            IF ( ip>=0 ) icsflt(ip) = j
             d = d+j
             DO jp = ip+1, numprocs-1
-                !-- number of elements is zero, displacement is equal to previous
+!--             number of elements is zero, displacement is equal to previous
                 icsflt(jp) = 0
                 dcsflt(jp) = d
             ENDDO
             
-            !-- deallocate temporary acsf array
-            ! DEALLOCATE(acsf) - ifort has a problem with deallocation of allocatable target
-            ! via pointing pointer - we need to test original targets
-            IF ( ALLOCATED(acsf1) ) THEN
+!--         deallocate temporary acsf array
+!--         DEALLOCATE(acsf) - ifort has a problem with deallocation of allocatable target
+!--         via pointing pointer - we need to test original targets
+            IF ( ALLOCATED(acsf1) )  THEN
                 DEALLOCATE(acsf1)
             ENDIF
-            IF ( ALLOCATED(acsf2) ) THEN
+            IF ( ALLOCATED(acsf2) )  THEN
                 DEALLOCATE(acsf2)
             ENDIF
                     
 #if defined( __parallel )
-            !-- scatter and gather the number of elements to and from all processor
-            !-- and calculate displacements
+!--         scatter and gather the number of elements to and from all processor
+!--         and calculate displacements
             CALL mpi_alltoall(icsflt,1,MPI_INTEGER,ipcsflt,1,MPI_INTEGER,comm2d, ierr)
             
@@ -1421,5 +1726,5 @@
             ENDDO
         
-            !-- exchange csf fields between processors
+!--         exchange csf fields between processors
             ALLOCATE( pcsflt(ndcsf,max(npcsfl,ndcsf)) )
             ALLOCATE( kpcsflt(kdcsf,max(npcsfl,kdcsf)) )
@@ -1429,8 +1734,4 @@
                 kpcsflt, kdcsf*ipcsflt, kdcsf*dpcsflt, MPI_INTEGER, comm2d, ierr)
             
-            IF ( debug_prints ) THEN
-                WRITE(9,*) myid, 'distribution CSF into processors finished'
-                FLUSH(9)
-            ENDIF
 #else
             npcsfl = ncsfl
@@ -1441,5 +1742,5 @@
 #endif
 
-            !-- deallocate temporary arrays
+!--         deallocate temporary arrays
             DEALLOCATE( csflt )
             DEALLOCATE( kcsflt )
@@ -1449,42 +1750,30 @@
             DEALLOCATE( dpcsflt )
 
-            !-- sort csf ( a version of quicksort )
-            IF ( debug_prints ) THEN
-                WRITE(9,*) myid, 'start csf sort2'
-                FLUSH(9)
-            ENDIF
+!--         sort csf ( a version of quicksort )
             CALL quicksort_csf2(kpcsflt, pcsflt, 1, npcsfl)
-            IF ( debug_prints ) THEN
-                WRITE(9,*) myid, 'sort2 csf finished'
-                FLUSH(9)
-            ENDIF
-
-            !-- aggregate canopy sink factor records with identical box & source
-            !-- againg across all values from all processors
-            IF ( npcsfl > 0 ) THEN
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) myid, 'csf merge of all values with', npcsfl, 'boxes'
-                    FLUSH(9)
-                ENDIF
+
+!--         aggregate canopy sink factor records with identical box & source
+!--         againg across all values from all processors
+            IF ( npcsfl > 0 )  THEN
                 icsf = 1 !< reading index
                 kcsf = 1 !< writing index
                 DO while (icsf < npcsfl)
-                    !-- here kpcsf(kcsf) already has values from kpcsf(icsf)
-                    IF ( kpcsflt(3,icsf) == kpcsflt(3,icsf+1) .AND. &
-                         kpcsflt(2,icsf) == kpcsflt(2,icsf+1) .AND. &
-                         kpcsflt(1,icsf) == kpcsflt(1,icsf+1) .AND. &
-                         kpcsflt(4,icsf) == kpcsflt(4,icsf+1) ) THEN
-                        !-- We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
-                        !-- probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
-                        !-- might mean that the traced beam passes longer through the canopy box.
-                        IF ( pcsflt(1,kcsf) < pcsflt(1,icsf+1) ) THEN
+!--                 here kpcsf(kcsf) already has values from kpcsf(icsf)
+                    IF ( kpcsflt(3,icsf) == kpcsflt(3,icsf+1)  .AND.  &
+                         kpcsflt(2,icsf) == kpcsflt(2,icsf+1)  .AND.  &
+                         kpcsflt(1,icsf) == kpcsflt(1,icsf+1)  .AND.  &
+                         kpcsflt(4,icsf) == kpcsflt(4,icsf+1) )  THEN
+!--                     We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
+!--                     probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
+!--                     might mean that the traced beam passes longer through the canopy box.
+                        IF ( pcsflt(1,kcsf) < pcsflt(1,icsf+1) )  THEN
                             pcsflt(2,kcsf) = pcsflt(2,icsf+1)
                         ENDIF
                         pcsflt(1,kcsf) = pcsflt(1,kcsf) + pcsflt(1,icsf+1)
 
-                        !-- advance reading index, keep writing index
+!--                     advance reading index, keep writing index
                         icsf = icsf + 1
                     ELSE
-                        !-- not identical, just advance and copy
+!--                     not identical, just advance and copy
                         icsf = icsf + 1
                         kcsf = kcsf + 1
@@ -1493,10 +1782,6 @@
                     ENDIF
                 ENDDO
-                !-- last written item is now also the last item in valid part of array
+!--             last written item is now also the last item in valid part of array
                 npcsfl = kcsf
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) myid, 'csf merge of all values completed,', npcsfl, 'boxes remaining'
-                    FLUSH(9)
-                ENDIF
             ENDIF
             
@@ -1514,8 +1799,8 @@
         svfsum = 0._wp
         DO isvf = 1, nsvfl
-            !-- normalize svf per target face
-            IF ( asvf(ksvf)%isurflt /= isurflt_prev ) THEN
-                IF ( isurflt_prev /= -1 .AND. svfsum /= 0._wp ) THEN
-                    !-- TODO detect and log when normalization differs too much from 1
+!--         normalize svf per target face
+            IF ( asvf(ksvf)%isurflt /= isurflt_prev )  THEN
+                IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
+!--                 TODO detect and log when normalization differs too much from 1
                     svf(1, isvf_surflt:isvf-1) = svf(1, isvf_surflt:isvf-1) / svfsum
                 ENDIF
@@ -1530,26 +1815,26 @@
             svfsurf(:, isvf) = (/ asvf(ksvf)%isurflt, asvf(ksvf)%isurfs /)
                     
-            !-- next element
+!--         next element
             ksvf = ksvf + 1    
         ENDDO
         
-        IF ( isurflt_prev /= -1 .AND. svfsum /= 0._wp ) THEN
-            !-- TODO detect and log when normalization differs too much from 1
+        IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
+!--         TODO detect and log when normalization differs too much from 1
             svf(1, isvf_surflt:nsvfl) = svf(1, isvf_surflt:nsvfl) / svfsum
         ENDIF
         
-        !-- deallocate temporary asvf array
-        ! DEALLOCATE(asvf) - ifort has a problem with deallocation of allocatable target
-        ! via pointing pointer - we need to test original targets
-        IF ( ALLOCATED(asvf1) ) THEN
+!--     deallocate temporary asvf array
+!--     DEALLOCATE(asvf) - ifort has a problem with deallocation of allocatable target
+!--     via pointing pointer - we need to test original targets
+        IF ( ALLOCATED(asvf1) )  THEN
             DEALLOCATE(asvf1)
         ENDIF
-        IF ( ALLOCATED(asvf2) ) THEN
+        IF ( ALLOCATED(asvf2) )  THEN
             DEALLOCATE(asvf2)
         ENDIF
 
-        IF (plant_canopy) THEN
+        IF ( plant_canopy )  THEN
             CALL location_message( '    calculation of the complete CSF part of the array', .TRUE. )
-            IF ( npcsfl > 0 ) THEN
+            IF ( npcsfl > 0 )  THEN
                 DO isvf = 1, npcsfl
                     svf(:,nsvfl+isvf) = pcsflt(:,isvf)
@@ -1559,5 +1844,5 @@
             ENDIF
             
-            !-- deallocation of temporary arrays
+!--         deallocation of temporary arrays
             DEALLOCATE( pcsflt )
             DEALLOCATE( kpcsflt )
